/* A Bison parser, made by GNU Bison 2.1.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003, 2004, 2005 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin Street, Fifth Floor,
   Boston, MA 02110-1301, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.1"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     Identifier = 258,
     String = 259,
     Constant = 260,
     LAYER = 261,
     CONTEXT = 262,
     SUBJECTIVE = 263,
     INFERRED = 264,
     QUESTION = 265,
     THRU = 266,
     NO_COMBINED_MAP = 267,
     NO_PROBABILITY_MAPS = 268,
     COMBINED_MAP = 269,
     ASPECT = 270,
     GREY = 271,
     HISTO = 272,
     RAINBOW = 273,
     RAMP = 274,
     RANDOM = 275,
     REDYELLOWGREEN = 276,
     WAVE = 277
   };
#endif
/* Tokens.  */
#define Identifier 258
#define String 259
#define Constant 260
#define LAYER 261
#define CONTEXT 262
#define SUBJECTIVE 263
#define INFERRED 264
#define QUESTION 265
#define THRU 266
#define NO_COMBINED_MAP 267
#define NO_PROBABILITY_MAPS 268
#define COMBINED_MAP 269
#define ASPECT 270
#define GREY 271
#define HISTO 272
#define RAINBOW 273
#define RAMP 274
#define RANDOM 275
#define REDYELLOWGREEN 276
#define WAVE 277




/* Copy the first part of user declarations.  */
#line 12 "binfer.y"


#include "symtab.h"
#include <stdlib.h>
#include <math.h>
#include "local_proto.h"
    struct symtab table;
    struct symtab *cur_sym;
    struct symtab *cur_att;
    struct names namelist;
    struct names problist;
    char probbuf[256];
    char reclassbuf[256];
    int valno = 1;
    int expected_type;
    int value_type;
    extern int verbose;
    extern int probabilitymaps;
    extern int combinedmap;
    extern int colortable;



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 35 "binfer.y"
typedef union YYSTYPE {
    char *y_sym;
} YYSTYPE;
/* Line 196 of yacc.c.  */
#line 156 "/var/tmp/oden/BUILD/grass-5.4.0/grass-build/src/raster/r.binfer/y.tab.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 219 of yacc.c.  */
#line 168 "/var/tmp/oden/BUILD/grass-5.4.0/grass-build/src/raster/r.binfer/y.tab.c"

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T) && (defined (__STDC__) || defined (__cplusplus))
# include <stddef.h> /* INFRINGES ON USER NAME SPACE */
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#ifndef YY_
# if YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if defined (__STDC__) || defined (__cplusplus)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     define YYINCLUDED_STDLIB_H
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2005 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM ((YYSIZE_T) -1)
#  endif
#  ifdef __cplusplus
extern "C" {
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if (! defined (malloc) && ! defined (YYINCLUDED_STDLIB_H) \
	&& (defined (__STDC__) || defined (__cplusplus)))
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if (! defined (free) && ! defined (YYINCLUDED_STDLIB_H) \
	&& (defined (__STDC__) || defined (__cplusplus)))
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifdef __cplusplus
}
#  endif
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short int yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short int) + sizeof (YYSTYPE))			\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short int yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   117

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  36
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  53
/* YYNRULES -- Number of rules. */
#define YYNRULES  89
/* YYNRULES -- Number of states. */
#define YYNSTATES  155

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   277

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,    33,     2,     2,
      23,    24,     2,     2,    31,     2,    32,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,    34,    35,
      29,     2,    30,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,    25,     2,    26,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    27,     2,    28,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short int yyprhs[] =
{
       0,     0,     3,     4,     7,    10,    11,    14,    16,    18,
      21,    24,    27,    30,    33,    36,    39,    42,    45,    49,
      54,    55,    61,    64,    68,    69,    75,    76,    81,    84,
      88,    89,    94,    95,    99,   101,   104,   106,   109,   113,
     116,   118,   120,   121,   127,   130,   134,   135,   141,   146,
     149,   153,   154,   158,   159,   166,   167,   173,   174,   183,
     184,   188,   190,   194,   196,   200,   201,   211,   212,   214,
     216,   218,   220,   222,   224,   226,   228,   232,   235,   239,
     241,   245,   247,   248,   253,   255,   257,   259,   261,   263
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      37,     0,    -1,    -1,    38,    39,    -1,    40,    42,    -1,
      -1,    40,    41,    -1,    12,    -1,    13,    -1,    14,    15,
      -1,    14,    16,    -1,    14,    17,    -1,    14,    18,    -1,
      14,    19,    -1,    14,    20,    -1,    14,    21,    -1,    14,
      22,    -1,    43,    68,    -1,    43,    57,    68,    -1,    43,
      57,    66,    68,    -1,    -1,     6,    34,    44,    45,    88,
      -1,    46,    85,    -1,    45,    46,    85,    -1,    -1,    83,
      34,    47,    48,    82,    -1,    -1,    23,    50,    49,    84,
      -1,    31,    50,    -1,    49,    31,    50,    -1,    -1,    83,
      51,    52,    82,    -1,    -1,    25,    53,    87,    -1,    55,
      -1,    55,    54,    -1,    54,    -1,    54,    55,    -1,    56,
      11,    56,    -1,    55,    56,    -1,    56,    -1,     5,    -1,
      -1,     7,    34,    58,    59,    88,    -1,    60,    85,    -1,
      59,    60,    85,    -1,    -1,    83,    34,    61,    62,    82,
      -1,    23,    64,    63,    84,    -1,    31,    64,    -1,    63,
      31,    64,    -1,    -1,    83,    65,    82,    -1,    -1,     8,
      34,    67,    60,    85,    88,    -1,    -1,     9,    34,    69,
      70,    88,    -1,    -1,    83,    34,    71,    72,    23,    74,
      84,    85,    -1,    -1,    27,    73,    86,    -1,    83,    -1,
      73,    31,    83,    -1,    75,    -1,    74,    31,    75,    -1,
      -1,    83,    76,    77,    78,    25,    80,    79,    35,    87,
      -1,    -1,    15,    -1,    16,    -1,    17,    -1,    18,    -1,
      19,    -1,    20,    -1,    21,    -1,    22,    -1,    29,     5,
      30,    -1,    35,    80,    -1,    79,    35,    80,    -1,    81,
      -1,    80,    31,    81,    -1,     5,    -1,    -1,    27,    10,
       4,    86,    -1,     3,    -1,    24,    -1,    32,    -1,    28,
      -1,    26,    -1,    33,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short int yyrline[] =
{
       0,    80,    80,    80,    88,    90,    92,    95,   100,   106,
     116,   126,   136,   146,   156,   166,   176,   188,   189,   190,
     194,   194,   204,   205,   208,   208,   221,   223,   226,   227,
     230,   230,   240,   242,   251,   252,   254,   255,   260,   264,
     266,   269,   273,   273,   283,   284,   287,   287,   300,   303,
     304,   307,   307,   318,   318,   329,   329,   340,   340,   350,
     352,   355,   358,   365,   366,   369,   369,   380,   382,   392,
     402,   412,   422,   432,   442,   452,   464,   471,   476,   483,
     487,   494,   497,   498,   502,   504,   505,   506,   507,   508
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "Identifier", "String", "Constant",
  "LAYER", "CONTEXT", "SUBJECTIVE", "INFERRED", "QUESTION", "THRU",
  "NO_COMBINED_MAP", "NO_PROBABILITY_MAPS", "COMBINED_MAP", "ASPECT",
  "GREY", "HISTO", "RAINBOW", "RAMP", "RANDOM", "REDYELLOWGREEN", "WAVE",
  "'('", "')'", "'['", "']'", "'{'", "'}'", "'<'", "'>'", "','", "'.'",
  "'%'", "':'", "';'", "$accept", "Program", "@1", "Script",
  "Output_Options", "Output_Option", "MainScript", "Layer_Section", "@2",
  "Layer_Att_Declarations", "Layer_Att_Declaration", "@3",
  "Layer_Value_List", "Layer_Value_Sublist", "Layer_Value", "@4",
  "Category_Range", "Reclass_Rule", "Input_Cat_Range", "Input_Cat_List",
  "Input_Cat", "Context_Section", "@5", "Context_Att_Declarations",
  "Context_Att_Declaration", "@6", "Context_Value_List",
  "Context_Value_Sublist", "Context_Value", "@7", "Subjective_Section",
  "@8", "Inferred_Section", "@9", "Inferred_Att_Declaration", "@10",
  "Determinant_List", "Att_List", "Inferred_Value_List", "Inferred_Value",
  "@11", "Optional_Color_Table", "Prior_Probability",
  "Conditional_Probability_Table", "Probability_List", "Probability",
  "Question_Attachment", "Name", "rp", "ep", "rb", "rbr", "end", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short int yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,    40,    41,    91,    93,   123,   125,    60,
      62,    44,    46,    37,    58,    59
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    36,    38,    37,    39,    40,    40,    41,    41,    41,
      41,    41,    41,    41,    41,    41,    41,    42,    42,    42,
      44,    43,    45,    45,    47,    46,    48,    48,    49,    49,
      51,    50,    52,    52,    53,    53,    53,    53,    54,    55,
      55,    56,    58,    57,    59,    59,    61,    60,    62,    63,
      63,    65,    64,    67,    66,    69,    68,    71,    70,    72,
      72,    73,    73,    74,    74,    76,    75,    77,    77,    77,
      77,    77,    77,    77,    77,    77,    78,    79,    79,    80,
      80,    81,    82,    82,    83,    84,    85,    86,    87,    88
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     0,     2,     2,     0,     2,     1,     1,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     3,     4,
       0,     5,     2,     3,     0,     5,     0,     4,     2,     3,
       0,     4,     0,     3,     1,     2,     1,     2,     3,     2,
       1,     1,     0,     5,     2,     3,     0,     5,     4,     2,
       3,     0,     3,     0,     6,     0,     5,     0,     8,     0,
       3,     1,     3,     1,     3,     0,     9,     0,     1,     1,
       1,     1,     1,     1,     1,     1,     3,     2,     3,     1,
       3,     1,     0,     4,     1,     1,     1,     1,     1,     1
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
       2,     0,     5,     1,     3,     0,     0,     7,     8,     0,
       6,     4,     0,    20,     9,    10,    11,    12,    13,    14,
      15,    16,     0,     0,     0,    17,     0,    42,    55,     0,
       0,    18,    84,     0,     0,     0,     0,     0,    53,    19,
      89,     0,    21,    86,    22,    24,     0,     0,     0,     0,
       0,     0,    23,    26,     0,    43,    44,    46,    56,    57,
       0,     0,    82,    45,     0,    59,     0,     0,    30,     0,
      25,     0,    82,     0,     0,    54,     0,     0,    32,     0,
       0,    51,    47,     0,    61,     0,    28,    85,     0,    27,
       0,    82,     0,     0,     0,    82,    87,     0,    60,     0,
      63,    65,    29,    41,     0,    36,    34,    40,    31,    83,
      49,     0,    48,    52,    62,     0,     0,    67,    88,    33,
      37,    40,    35,    39,     0,    50,    64,    58,    68,    69,
      70,    71,    72,    73,    74,    75,     0,    39,    38,     0,
       0,     0,     0,    76,    81,     0,    79,     0,     0,     0,
      80,    77,     0,    78,    66
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short int yydefgoto[] =
{
      -1,     1,     2,     4,     5,    10,    11,    12,    26,    33,
      34,    53,    62,    77,    67,    78,    91,   104,   105,   106,
     107,    24,    36,    46,    47,    64,    72,    94,    80,    95,
      30,    51,    25,    37,    49,    65,    74,    83,    99,   100,
     117,   136,   140,   149,   145,   146,    70,    48,    89,    44,
      98,   119,    42
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -101
static const yysigned_char yypact[] =
{
    -101,    33,  -101,  -101,  -101,    26,    15,  -101,  -101,    36,
    -101,  -101,    54,  -101,  -101,  -101,  -101,  -101,  -101,  -101,
    -101,  -101,    34,    35,    57,  -101,    67,  -101,  -101,    38,
      64,  -101,  -101,    -2,    42,    41,    67,    67,  -101,  -101,
    -101,    42,  -101,  -101,  -101,  -101,    -2,    42,    44,    43,
      45,    67,  -101,    58,    42,  -101,  -101,  -101,  -101,  -101,
      42,    67,    53,  -101,    59,    56,    43,    55,  -101,    74,
    -101,    67,    53,    67,    65,  -101,    67,    -8,    62,    94,
      68,  -101,  -101,   -14,  -101,    67,  -101,  -101,    67,  -101,
      95,    53,    73,    67,     3,    53,  -101,    67,  -101,    12,
    -101,  -101,  -101,  -101,    76,    95,    95,    92,  -101,  -101,
    -101,    67,  -101,  -101,  -101,    67,    42,    75,  -101,  -101,
      95,  -101,  -101,    92,    95,  -101,  -101,  -101,  -101,  -101,
    -101,  -101,  -101,  -101,  -101,  -101,    77,  -101,  -101,    99,
      80,    78,   102,  -101,  -101,    13,  -101,   102,   102,    79,
    -101,    81,    -1,    81,  -101
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
    -101,  -101,  -101,  -101,  -101,  -101,  -101,  -101,  -101,  -101,
      82,  -101,  -101,  -101,   -58,  -101,  -101,  -101,     4,     6,
    -100,  -101,  -101,  -101,    -9,  -101,  -101,  -101,   -83,  -101,
    -101,  -101,   -11,  -101,  -101,  -101,  -101,  -101,  -101,    -6,
    -101,  -101,  -101,  -101,   -88,   -34,   -69,   -26,   -53,   -39,
      24,   -35,   -37
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned char yytable[] =
{
      35,    32,    52,    82,   144,   121,   123,    35,    56,    55,
     110,    50,    58,    31,    96,    63,    87,    97,    86,    39,
     137,    66,   108,    88,   138,   118,   113,    87,   125,    75,
     102,    40,     6,     3,   111,    68,    87,    54,     7,     8,
       9,   112,    60,   115,   147,    81,   116,    84,   148,    13,
      68,    14,    15,    16,    17,    18,    19,    20,    21,   101,
     151,    22,    68,    23,   153,    29,    23,    81,    27,    28,
      32,   114,    38,    23,    43,    45,    40,   127,    57,    59,
      69,    61,    71,    73,    79,    81,    76,    90,    85,   101,
     128,   129,   130,   131,   132,   133,   134,   135,    92,    93,
     103,    96,   118,   124,   141,   142,   139,   144,   143,   126,
     122,   120,   147,   150,   152,    41,   109,   154
};

static const unsigned char yycheck[] =
{
      26,     3,    41,    72,     5,   105,   106,    33,    47,    46,
      93,    37,    49,    24,    28,    54,    24,    31,    76,    30,
     120,    60,    91,    31,   124,    26,    95,    24,   111,    66,
      88,    33,     6,     0,    31,    61,    24,    46,    12,    13,
      14,    94,    51,    31,    31,    71,    99,    73,    35,    34,
      76,    15,    16,    17,    18,    19,    20,    21,    22,    85,
     148,     7,    88,     9,   152,     8,     9,    93,    34,    34,
       3,    97,    34,     9,    32,    34,    33,   116,    34,    34,
      27,    23,    23,    27,    10,   111,    31,    25,    23,   115,
      15,    16,    17,    18,    19,    20,    21,    22,     4,    31,
       5,    28,    26,    11,     5,    25,    29,     5,    30,   115,
     106,   105,    31,   147,    35,    33,    92,   152
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    37,    38,     0,    39,    40,     6,    12,    13,    14,
      41,    42,    43,    34,    15,    16,    17,    18,    19,    20,
      21,    22,     7,     9,    57,    68,    44,    34,    34,     8,
      66,    68,     3,    45,    46,    83,    58,    69,    34,    68,
      33,    46,    88,    32,    85,    34,    59,    60,    83,    70,
      83,    67,    85,    47,    60,    88,    85,    34,    88,    34,
      60,    23,    48,    85,    61,    71,    85,    50,    83,    27,
      82,    23,    62,    27,    72,    88,    31,    49,    51,    10,
      64,    83,    82,    73,    83,    23,    50,    24,    31,    84,
      25,    52,     4,    31,    63,    65,    28,    31,    86,    74,
      75,    83,    50,     5,    53,    54,    55,    56,    82,    86,
      64,    31,    84,    82,    83,    31,    84,    76,    26,    87,
      55,    56,    54,    56,    11,    64,    75,    85,    15,    16,
      17,    18,    19,    20,    21,    22,    77,    56,    56,    29,
      78,     5,    25,    30,     5,    80,    81,    31,    35,    79,
      81,    80,    35,    80,    87
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (0)


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (N)								\
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (0)
#endif


/* YY_LOCATION_PRINT -- Print the location on the stream.
   This macro was not mandated originally: define only if we know
   we won't break user code: when these are the locations we know.  */

#ifndef YY_LOCATION_PRINT
# if YYLTYPE_IS_TRIVIAL
#  define YY_LOCATION_PRINT(File, Loc)			\
     fprintf (File, "%d.%d-%d.%d",			\
              (Loc).first_line, (Loc).first_column,	\
              (Loc).last_line,  (Loc).last_column)
# else
#  define YY_LOCATION_PRINT(File, Loc) ((void) 0)
# endif
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr,					\
                  Type, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short int *bottom, short int *top)
#else
static void
yy_stack_print (bottom, top)
    short int *bottom;
    short int *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname[yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname[yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      size_t yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

#endif /* YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);


# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The look-ahead symbol.  */
int yychar;

/* The semantic value of the look-ahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()
    ;
#endif
#endif
{
  
  int yystate;
  int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Look-ahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short int yyssa[YYINITDEPTH];
  short int *yyss = yyssa;
  short int *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short int *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short int *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a look-ahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to look-ahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a look-ahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid look-ahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the look-ahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 80 "binfer.y"
    { init(); }
    break;

  case 3:
#line 81 "binfer.y"
    { 
                 check_table(&table,verbose);
                 if ( verbose ) fprintf(stderr,"\nAll input parsed.\n");
                 return(-1);
             }
    break;

  case 7:
#line 95 "binfer.y"
    { 
                          combinedmap = 0;
                          fprintf(stderr,"NoCombinedMap option set.\n"); 
                      }
    break;

  case 8:
#line 101 "binfer.y"
    { 
                          probabilitymaps = 0;
                          fprintf(stderr,"NoProbabiltyMaps option set.\n"); 
                      }
    break;

  case 9:
#line 107 "binfer.y"
    { 
                          if ( combinedmap ) {
                              colortable = AspectColors;
                              fprintf(stderr,"Combined map colortable set to aspect colors.\n");
                          } else {
                              fprintf(stderr,"Warning: Combined map colortable not set.\n");
                              fprintf(stderr,"NoCombinedMap option is set.\n");
                          }
                      }
    break;

  case 10:
#line 117 "binfer.y"
    { 
                          if ( combinedmap ) {
                              colortable = GreyScale;
                              fprintf(stderr,"Combined map colortable set to grey scale.\n");
                          } else {
                              fprintf(stderr,"Warning: Combined map colortable not set.\n");
                              fprintf(stderr,"NoCombinedMap option is set.\n");
                          }
                      }
    break;

  case 11:
#line 127 "binfer.y"
    { 
                          if ( combinedmap ) {
                              colortable = HistoGreyScale;
                              fprintf(stderr,"Combined map colortable set to histogram stretched grey scale.\n");
                          } else {
                              fprintf(stderr,"Warning: Combined map colortable not set.\n");
                              fprintf(stderr,"NoCombinedMap option is set.\n");
                          }
                      }
    break;

  case 12:
#line 137 "binfer.y"
    { 
                          if ( combinedmap ) {
                              colortable = Rainbow;
                              fprintf(stderr,"Combined map colortable set to rainbow colors.\n");
                          } else {
                              fprintf(stderr,"Warning: Combined map colortable not set.\n");
                              fprintf(stderr,"NoCombinedMap option is set.\n");
                          }
                      }
    break;

  case 13:
#line 147 "binfer.y"
    { 
                          if ( combinedmap ) {
                              colortable = Ramp;
                              fprintf(stderr,"Combined map colortable set to color ramp.\n");
                          } else {
                              fprintf(stderr,"Warning: Combined map colortable not set.\n");
                              fprintf(stderr,"NoCombinedMap option is set.\n");
                          }
                      }
    break;

  case 14:
#line 157 "binfer.y"
    { 
                          if ( combinedmap ) {
                              colortable = Random;
                              fprintf(stderr,"Combined map colortable set to random colors.\n");
                          } else {
                              fprintf(stderr,"Warning: Combined map colortable not set.\n");
                              fprintf(stderr,"NoCombinedMap option is set.\n");
                          }
                      }
    break;

  case 15:
#line 167 "binfer.y"
    { 
                          if ( combinedmap ) {
                              colortable = RYG;
                              fprintf(stderr,"Combined map colortable set to red yellow green.\n");
                          } else {
                              fprintf(stderr,"Warning: Combined map colortable not set.\n");
                              fprintf(stderr,"NoCombinedMap option is set.\n");
                          }
                      }
    break;

  case 16:
#line 177 "binfer.y"
    { 
                          if ( combinedmap ) {
                              colortable = Wave;
                              fprintf(stderr,"Combined map colortable set to color wave.\n");
                          } else {
                              fprintf(stderr,"Warning: Combined map colortable not set.\n");
                              fprintf(stderr,"NoCombinedMap option is set.\n");
                          }
                      }
    break;

  case 20:
#line 194 "binfer.y"
    { 
                       expected_type = AttributeSymbol;
                       value_type = LayerAttribute; 
                   }
    break;

  case 21:
#line 199 "binfer.y"
    { 
                       if ( verbose ) fprintf(stderr,"\nParsed layers section.\n"); 
                   }
    break;

  case 24:
#line 208 "binfer.y"
    { 
                   cur_sym = s_create((yyvsp[-1].y_sym),expected_type,value_type);
                   expected_type = ValueSymbol; 
               }
    break;

  case 25:
#line 214 "binfer.y"
    { 
                   expected_type = AttributeSymbol;
                   if ( (yyvsp[0].y_sym) != (char *)0 )
                       cur_att->question = strsave((yyvsp[0].y_sym)); 
                   valno = 1;
               }
    break;

  case 30:
#line 230 "binfer.y"
    { 
               cur_sym = s_create((yyvsp[0].y_sym),expected_type,value_type); 
           }
    break;

  case 31:
#line 234 "binfer.y"
    { 
               if ( (yyvsp[0].y_sym) != (char *)0 )
                   cur_sym->question = strsave((yyvsp[0].y_sym)); 
           }
    break;

  case 33:
#line 243 "binfer.y"
    { 
               cur_sym->element.val->desc.layer->cat_num = (CELL)valno;
            
               sprintf(cur_sym->reclass,"%s = %d %s",strsave((yyvsp[-1].y_sym)),valno++,
                       cur_sym->name);
           }
    break;

  case 34:
#line 251 "binfer.y"
    { (yyval.y_sym) = strsave((yyvsp[0].y_sym)); }
    break;

  case 35:
#line 252 "binfer.y"
    { sprintf(reclassbuf,"%s %s",(yyvsp[-1].y_sym),(yyvsp[0].y_sym));
                                       (yyval.y_sym) = strsave(reclassbuf); }
    break;

  case 36:
#line 254 "binfer.y"
    { (yyval.y_sym) = strsave((yyvsp[0].y_sym)); }
    break;

  case 37:
#line 255 "binfer.y"
    { sprintf(reclassbuf,"%s %s",(yyvsp[-1].y_sym),(yyvsp[0].y_sym));
                                       (yyval.y_sym) = strsave(reclassbuf); }
    break;

  case 38:
#line 260 "binfer.y"
    { sprintf(reclassbuf,"%s thru %s",(yyvsp[-2].y_sym),(yyvsp[0].y_sym));
                                 (yyval.y_sym) = strsave(reclassbuf); }
    break;

  case 39:
#line 264 "binfer.y"
    { sprintf(reclassbuf,"%s %s",(yyvsp[-1].y_sym),(yyvsp[0].y_sym));
                                 (yyval.y_sym) = strsave(reclassbuf); }
    break;

  case 40:
#line 266 "binfer.y"
    { (yyval.y_sym) = strsave((yyvsp[0].y_sym)); }
    break;

  case 41:
#line 269 "binfer.y"
    { (yyval.y_sym) = strsave((yyvsp[0].y_sym));}
    break;

  case 42:
#line 273 "binfer.y"
    { 
                      expected_type = AttributeSymbol;
                      value_type = ContextAttribute; 
                  }
    break;

  case 43:
#line 278 "binfer.y"
    { 
               if ( verbose ) fprintf(stderr,"\nParsed context section.\n"); 
           }
    break;

  case 46:
#line 287 "binfer.y"
    { 
                    cur_att = cur_sym = s_create((yyvsp[-1].y_sym),expected_type,value_type);
                    expected_type = ValueSymbol; 
               }
    break;

  case 47:
#line 292 "binfer.y"
    { 
                   expected_type = AttributeSymbol;
                   if ( (yyvsp[0].y_sym) != (char *)0 )
                       cur_att->question = strsave((yyvsp[0].y_sym)); 
               }
    break;

  case 51:
#line 307 "binfer.y"
    { 
               cur_sym = s_create((yyvsp[0].y_sym),expected_type,value_type); 
           }
    break;

  case 52:
#line 311 "binfer.y"
    { 
               if ( (yyvsp[0].y_sym) != (char *)0 )
                   cur_sym->question = strsave((yyvsp[0].y_sym)); 
           }
    break;

  case 53:
#line 318 "binfer.y"
    { 
                         expected_type = AttributeSymbol;
                         value_type = SubjectiveAttribute; 
                     }
    break;

  case 54:
#line 323 "binfer.y"
    { 
                         if ( verbose ) 
                             fprintf(stderr,"\nParsed subjective section.\n"); 
                     }
    break;

  case 55:
#line 329 "binfer.y"
    { 
                        expected_type = AttributeSymbol;
                        value_type = InferredAttribute; 
                    }
    break;

  case 56:
#line 334 "binfer.y"
    { 
                        if ( verbose ) 
                            fprintf(stderr,"\nParsed inferred section.\n"); 
                    }
    break;

  case 57:
#line 340 "binfer.y"
    { 
                   cur_sym = s_create((yyvsp[-1].y_sym),expected_type,value_type);
                   expected_type = ValueSymbol; 
               }
    break;

  case 58:
#line 345 "binfer.y"
    { 
                   expected_type = AttributeSymbol; 
               }
    break;

  case 61:
#line 355 "binfer.y"
    { 
               if (!add_name((yyvsp[0].y_sym))) yyerror("Name not stored"); 
           }
    break;

  case 62:
#line 359 "binfer.y"
    { 
               if (!add_name((yyvsp[0].y_sym))) yyerror("Name not stored"); 
           }
    break;

  case 65:
#line 369 "binfer.y"
    { 
               cur_sym = s_create((yyvsp[0].y_sym),expected_type,value_type); 
           }
    break;

  case 66:
#line 374 "binfer.y"
    {
                sprintf(probbuf,"%s%s;",(yyvsp[-3].y_sym),(yyvsp[-2].y_sym));
                if (!add_prob_list(probbuf)) yyerror("Problist not stored");
            }
    break;

  case 68:
#line 382 "binfer.y"
    {
                 if ( probabilitymaps ) {
                     cur_sym->colortable = AspectColors;
                 } else {
                     fprintf(stderr,
                             "Warning: %s probability map colortable not set.\n"
                             ,cur_sym->name);
                     fprintf(stderr,"NoProbabilityMaps option is set.\n");
                 }
           }
    break;

  case 69:
#line 392 "binfer.y"
    {
                 if ( probabilitymaps ) {
                     cur_sym->colortable = GreyScale;
                 } else {
                     fprintf(stderr,
                             "Warning: %s probability map colortable not set.\n"
                             ,cur_sym->name);
                     fprintf(stderr,"NoProbabilityMaps option is set.\n");
                 }
           }
    break;

  case 70:
#line 402 "binfer.y"
    {
                 if ( probabilitymaps ) {
                     cur_sym->colortable = HistoGreyScale;
                 } else {
                     fprintf(stderr,
                             "Warning: %s probability map colortable not set.\n"
                             ,cur_sym->name);
                     fprintf(stderr,"NoProbabilityMaps option is set.\n");
                 }
           }
    break;

  case 71:
#line 412 "binfer.y"
    {
                 if ( probabilitymaps ) {
                     cur_sym->colortable = Rainbow;
                 } else {
                     fprintf(stderr,
                             "Warning: %s probability map colortable not set.\n"
                             ,cur_sym->name);
                     fprintf(stderr,"NoProbabilityMaps option is set.\n");
                 }
           }
    break;

  case 72:
#line 422 "binfer.y"
    {
                 if ( probabilitymaps ) {
                     cur_sym->colortable = Ramp;
                 } else {
                     fprintf(stderr,
                             "Warning: %s probability map colortable not set.\n"
                             ,cur_sym->name);
                     fprintf(stderr,"NoProbabilityMaps option is set.\n");
                 }
           }
    break;

  case 73:
#line 432 "binfer.y"
    {
                 if ( probabilitymaps ) {
                     cur_sym->colortable = Random;
                 } else {
                     fprintf(stderr,
                             "Warning: %s probability map colortable not set.\n"
                             ,cur_sym->name);
                     fprintf(stderr,"NoProbabilityMaps option is set.\n");
                 }
           }
    break;

  case 74:
#line 442 "binfer.y"
    {
                 if ( probabilitymaps ) {
                     cur_sym->colortable = RYG;
                 } else {
                     fprintf(stderr,
                             "Warning: %s probability map colortable not set.\n"
                             ,cur_sym->name);
                     fprintf(stderr,"NoProbabilityMaps option is set.\n");
                 }
           }
    break;

  case 75:
#line 452 "binfer.y"
    {
                 if ( probabilitymaps ) {
                     cur_sym->colortable = Wave;
                 } else {
                     fprintf(stderr,
                             "Warning: %s probability map colortable not set.\n"
                             ,cur_sym->name);
                     fprintf(stderr,"NoProbabilityMaps option is set.\n");
                 }
           }
    break;

  case 76:
#line 465 "binfer.y"
    { 
                cur_sym->element.val->desc.infr->prior_prob = atof((yyvsp[-1].y_sym)); 
            }
    break;

  case 77:
#line 472 "binfer.y"
    { 
                sprintf(probbuf,";%s",(yyvsp[0].y_sym)); 
                (yyval.y_sym) = strsave(probbuf);
            }
    break;

  case 78:
#line 477 "binfer.y"
    { 
                sprintf(probbuf,"%s;%s",(yyvsp[-2].y_sym),(yyvsp[0].y_sym));
                (yyval.y_sym) = strsave(probbuf);
            }
    break;

  case 79:
#line 484 "binfer.y"
    { 
                (yyval.y_sym) = strsave((yyvsp[0].y_sym)); 
            }
    break;

  case 80:
#line 488 "binfer.y"
    { 
                sprintf(probbuf,"%s,%s",(yyvsp[-2].y_sym),(yyvsp[0].y_sym));
                (yyval.y_sym) = strsave(probbuf);
            }
    break;

  case 81:
#line 494 "binfer.y"
    { (yyval.y_sym) = strsave((yyvsp[0].y_sym)); }
    break;

  case 82:
#line 497 "binfer.y"
    { (yyval.y_sym) = (char *)0; }
    break;

  case 83:
#line 498 "binfer.y"
    { (yyval.y_sym) = strsave((yyvsp[-1].y_sym)); }
    break;

  case 85:
#line 504 "binfer.y"
    { yyerrok; }
    break;

  case 86:
#line 505 "binfer.y"
    { yyerrok; }
    break;

  case 87:
#line 506 "binfer.y"
    { yyerrok; }
    break;

  case 88:
#line 507 "binfer.y"
    { yyerrok; }
    break;

  case 89:
#line 508 "binfer.y"
    { yyerrok; }
    break;


      default: break;
    }

/* Line 1126 of yacc.c.  */
#line 1846 "/var/tmp/oden/BUILD/grass-5.4.0/grass-build/src/raster/r.binfer/y.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  int yytype = YYTRANSLATE (yychar);
	  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytype]);
	  YYSIZE_T yysize = yysize0;
	  YYSIZE_T yysize1;
	  int yysize_overflow = 0;
	  char *yymsg = 0;
#	  define YYERROR_VERBOSE_ARGS_MAXIMUM 5
	  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
	  int yyx;

#if 0
	  /* This is so xgettext sees the translatable formats that are
	     constructed on the fly.  */
	  YY_("syntax error, unexpected %s");
	  YY_("syntax error, unexpected %s, expecting %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s or %s");
	  YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s");
#endif
	  char *yyfmt;
	  char const *yyf;
	  static char const yyunexpected[] = "syntax error, unexpected %s";
	  static char const yyexpecting[] = ", expecting %s";
	  static char const yyor[] = " or %s";
	  char yyformat[sizeof yyunexpected
			+ sizeof yyexpecting - 1
			+ ((YYERROR_VERBOSE_ARGS_MAXIMUM - 2)
			   * (sizeof yyor - 1))];
	  char const *yyprefix = yyexpecting;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 1;

	  yyarg[0] = yytname[yytype];
	  yyfmt = yystpcpy (yyformat, yyunexpected);

	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
		  {
		    yycount = 1;
		    yysize = yysize0;
		    yyformat[sizeof yyunexpected - 1] = '\0';
		    break;
		  }
		yyarg[yycount++] = yytname[yyx];
		yysize1 = yysize + yytnamerr (0, yytname[yyx]);
		yysize_overflow |= yysize1 < yysize;
		yysize = yysize1;
		yyfmt = yystpcpy (yyfmt, yyprefix);
		yyprefix = yyor;
	      }

	  yyf = YY_(yyformat);
	  yysize1 = yysize + yystrlen (yyf);
	  yysize_overflow |= yysize1 < yysize;
	  yysize = yysize1;

	  if (!yysize_overflow && yysize <= YYSTACK_ALLOC_MAXIMUM)
	    yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg)
	    {
	      /* Avoid sprintf, as that infringes on the user's name space.
		 Don't have undefined behavior even if the translation
		 produced a string with the wrong number of "%s"s.  */
	      char *yyp = yymsg;
	      int yyi = 0;
	      while ((*yyp = *yyf))
		{
		  if (*yyp == '%' && yyf[1] == 's' && yyi < yycount)
		    {
		      yyp += yytnamerr (yyp, yyarg[yyi++]);
		      yyf += 2;
		    }
		  else
		    {
		      yyp++;
		      yyf++;
		    }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    {
	      yyerror (YY_("syntax error"));
	      goto yyexhaustedlab;
	    }
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror (YY_("syntax error"));
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse look-ahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
        }
      else
	{
	  yydestruct ("Error: discarding", yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse look-ahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (0)
     goto yyerrorlab;

yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping", yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  *++yyvsp = yylval;


  /* Shift the error token. */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEOF && yychar != YYEMPTY)
     yydestruct ("Cleanup: discarding lookahead",
		 yytoken, &yylval);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK;
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 510 "binfer.y"



#include <stdio.h>

